## Perennial Master

The largest change is the removal from wpc of (1) the "<disc>" modality on the
crash condition, and (2) restrictions on the "level" of fancy updates that can
be used in the crash case, which was determined by a natural number k index of
wpc. (This natural number k is still a parameter of `wpc`, but it is
now meaningless, and will be removed later.)

`na_crash_inv` is replaced by `crash_borrow`. The basic API is similar,
except that there is no "level" associated with a `crash_borrow`, so they can be
opened around on any `wpc e {{ P }} {{ Q }}`, so long as `e` is not a value. The
other big change is that creating a crash borrow requires a `pre_borrow` --
these are generated by either taking a step, or by opening a special invariant
that always contains a `pre_borrow` around an atomic step. This means that only
a finite number of crash borrows can be created in a single step. However, this
is compensated for by the fact that when taking a step, a crash borrow can be
split, or two crash borrows can be joined.

Another change is that whereas creating an `na_crash_inv` separately generated
a `cfupd` that could be used subsequently cancel part of a crash condition,
"creating" and "canceling" have to be done simultaneously with the
`crash_borrow`. We introduce a new `init_cancel` modality that captures this
idea of creating/initializing a crash borrow and removing something from the
crash condition, which makes it possible to build up larger abstractions.

Under the hood, a `pre_borrow` is defined using a technique proposed by Jourdan
to "inflate" the number of laters that are generated by each step of execution
in the definitions of wp/wpc. This enables the `pre_borrow` to give a limited
form of the "later credits" idea proposed by Spies et al., where a pre_borrow
can be "spent" to remove a later from a context when proving a `wpc`.

## Perennial 2.0

N/A

## Perennial 1.0

N/A
