# Generated by rpcgen.py from rpc.x on Sun Apr 17 16:19:27 2005
import rpc_const as const
class opaque_auth:
    # XDR definition:
    # struct opaque_auth {
    #     auth_flavor flavor;
    #     opaque body<400>;
    # };
    def __init__(self, flavor=None, body=None):
        self.flavor = flavor
        self.body = body

    def __repr__(self):
        out = []
        if self.flavor is not None:
            out += ['flavor=%s' % const.auth_flavor.get(self.flavor, self.flavor)]
        if self.body is not None:
            out += ['body=%s' % repr(self.body)]
        return 'opaque_auth(%s)' % ', '.join(out)

class rpc_msg:
    # XDR definition:
    # struct rpc_msg {
    #     uint xid;
    #     union switch(msg_type mtype) {
    #         case CALL:
    #             call_body cbody;
    #         case REPLY:
    #             reply_body rbody;
    #     } body;
    # };
    def __init__(self, xid=None, body=None):
        self.xid = xid
        self.body = body

    def __repr__(self):
        out = []
        if self.xid is not None:
            out += ['xid=%s' % repr(self.xid)]
        if self.body is not None:
            out += ['body=%s' % repr(self.body)]
        return 'rpc_msg(%s)' % ', '.join(out)

class call_body:
    # XDR definition:
    # struct call_body {
    #     uint rpcvers;
    #     uint prog;
    #     uint vers;
    #     uint proc;
    #     opaque_auth cred;
    #     opaque_auth verf;
    # };
    def __init__(self, rpcvers=None, prog=None, vers=None, proc=None, cred=None, verf=None):
        self.rpcvers = rpcvers
        self.prog = prog
        self.vers = vers
        self.proc = proc
        self.cred = cred
        self.verf = verf

    def __repr__(self):
        out = []
        if self.rpcvers is not None:
            out += ['rpcvers=%s' % repr(self.rpcvers)]
        if self.prog is not None:
            out += ['prog=%s' % repr(self.prog)]
        if self.vers is not None:
            out += ['vers=%s' % repr(self.vers)]
        if self.proc is not None:
            out += ['proc=%s' % repr(self.proc)]
        if self.cred is not None:
            out += ['cred=%s' % repr(self.cred)]
        if self.verf is not None:
            out += ['verf=%s' % repr(self.verf)]
        return 'call_body(%s)' % ', '.join(out)

class reply_body:
    # XDR definition:
    # union reply_body switch(reply_stat stat) {
    #     case MSG_ACCEPTED:
    #         accepted_reply areply;
    #     case MSG_DENIED:
    #         rejected_reply rreply;
    # };
    def __init__(self, stat=None, areply=None, rreply=None):
        self.stat = stat
        self.areply = areply
        self.rreply = rreply

    def __repr__(self):
        out = []
        if self.stat is not None:
            out += ['stat=%s' % const.reply_stat.get(self.stat, self.stat)]
        if self.areply is not None:
            out += ['areply=%s' % repr(self.areply)]
        if self.rreply is not None:
            out += ['rreply=%s' % repr(self.rreply)]
        return 'reply_body(%s)' % ', '.join(out)

class accepted_reply:
    # XDR definition:
    # struct accepted_reply {
    #     opaque_auth verf;
    #     union switch(accept_stat stat) {
    #         case SUCCESS:
    #             opaque results[0];
    #         case PROG_MISMATCH:
    #             struct {
    #                 uint low;
    #                 uint high;
    #             } mismatch_info;
    #         default:
    #             void;
    #     } reply_data;
    # };
    def __init__(self, verf=None, reply_data=None):
        self.verf = verf
        self.reply_data = reply_data

    def __repr__(self):
        out = []
        if self.verf is not None:
            out += ['verf=%s' % repr(self.verf)]
        if self.reply_data is not None:
            out += ['reply_data=%s' % repr(self.reply_data)]
        return 'accepted_reply(%s)' % ', '.join(out)

class rejected_reply:
    # XDR definition:
    # union rejected_reply switch(reject_stat stat) {
    #     case RPC_MISMATCH:
    #         struct {
    #             uint low;
    #             uint high;
    #         } mismatch_info;
    #     case AUTH_ERROR:
    #         auth_stat astat;
    # };
    def __init__(self, stat=None, mismatch_info=None, astat=None):
        self.stat = stat
        self.mismatch_info = mismatch_info
        self.astat = astat

    def __repr__(self):
        out = []
        if self.stat is not None:
            out += ['stat=%s' % const.reject_stat.get(self.stat, self.stat)]
        if self.mismatch_info is not None:
            out += ['mismatch_info=%s' % repr(self.mismatch_info)]
        if self.astat is not None:
            out += ['astat=%s' % const.auth_stat.get(self.astat, self.astat)]
        return 'rejected_reply(%s)' % ', '.join(out)

